blob: 1e7609a467441cdd1b840a797c467f16f4d55d45 [file] [log] [blame]
Simon Glassbbb0b122011-10-15 05:48:21 +00001#
2# Copyright (c) 2011 The Chromium OS Authors.
3#
Wolfgang Denk1a459662013-07-08 09:37:19 +02004# SPDX-License-Identifier: GPL-2.0+
Simon Glassbbb0b122011-10-15 05:48:21 +00005#
6
7# This Makefile builds the internal U-Boot fdt if CONFIG_OF_CONTROL is
8# enabled. See doc/README.fdt-control for more details.
9
Stephen Warrenc8391a02013-07-24 10:09:19 -070010DTS_INCDIRS = $(SRCTREE)/board/$(VENDOR)/$(BOARD)/dts
11DTS_INCDIRS += $(SRCTREE)/board/$(VENDOR)/dts
12DTS_INCDIRS += $(SRCTREE)/arch/$(ARCH)/dts
13
Stephen Warrenf53932a2013-07-24 10:09:24 -070014DTS_CPPFLAGS := -x assembler-with-cpp -undef -D__DTS__ \
Stephen Warrenc8391a02013-07-24 10:09:19 -070015 -nostdinc $(addprefix -I,$(DTS_INCDIRS))
16
17DTC_FLAGS := -R 4 -p 0x1000 \
18 $(addprefix -i ,$(DTS_INCDIRS))
Simon Glassbbb0b122011-10-15 05:48:21 +000019
Simon Glassbbb0b122011-10-15 05:48:21 +000020# Use a constant name for this so we can access it from C code.
21# objcopy doesn't seem to allow us to set the symbol name independently of
22# the filename.
Masahiro Yamada9e414032014-02-04 17:24:24 +090023DT_BIN := $(obj)/dt.dtb
Simon Glassbbb0b122011-10-15 05:48:21 +000024
Masahiro Yamadaefcf8612014-02-04 17:24:40 +090025DEVICE_TREE ?= $(CONFIG_DEFAULT_DEVICE_TREE:"%"=%)
26ifeq ($(DEVICE_TREE),)
27$(DT_BIN): FORCE
28 echo >&2 "Please define CONFIG_DEFAULT_DEVICE_TREE in your board header file"
29else
Simon Glassbbb0b122011-10-15 05:48:21 +000030$(DT_BIN): $(TOPDIR)/board/$(VENDOR)/dts/$(DEVICE_TREE).dts
Stephen Warren32ac4bd2013-07-24 10:09:23 -070031 $(CPP) $(DTS_CPPFLAGS) $< -o $(DT_BIN).dts.tmp
Stephen Warrenc8391a02013-07-24 10:09:19 -070032 $(DTC) $(DTC_FLAGS) -O dtb -o ${DT_BIN} $(DT_BIN).dts.tmp
Masahiro Yamadaefcf8612014-02-04 17:24:40 +090033endif
Simon Glassbbb0b122011-10-15 05:48:21 +000034
35process_lds = \
36 $(1) | sed -r -n 's/^OUTPUT_$(2)[ ("]*([^")]*).*/\1/p'
37
38# Run the compiler and get the link script from the linker
Masahiro Yamada6825a952014-02-04 17:24:28 +090039GET_LDS = $(CC) $(c_flags) $(ld_flags) -Wl,--verbose 2>&1
Simon Glassbbb0b122011-10-15 05:48:21 +000040
Masahiro Yamada9e414032014-02-04 17:24:24 +090041$(obj)/dt.o: $(DT_BIN)
Simon Glassbbb0b122011-10-15 05:48:21 +000042 # We want the output format and arch.
43 # We also hope to win a prize for ugliest Makefile / shell interaction
44 # We look in the LDSCRIPT first.
45 # Then try the linker which should give us the answer.
46 # Then check it worked.
Horst Kronstorfera4ff4712012-07-12 02:58:32 +000047 [ -n "$(LDSCRIPT)" ] && \
48 oformat=`$(call process_lds,cat $(LDSCRIPT),FORMAT)` && \
49 oarch=`$(call process_lds,cat $(LDSCRIPT),ARCH)` ;\
Simon Glassbbb0b122011-10-15 05:48:21 +000050 \
51 [ -z $${oformat} ] && \
52 oformat=`$(call process_lds,$(GET_LDS),FORMAT)` ;\
53 [ -z $${oarch} ] && \
54 oarch=`$(call process_lds,$(GET_LDS),ARCH)` ;\
55 \
56 [ -z $${oformat} ] && \
57 echo "Cannot read OUTPUT_FORMAT from lds file $(LDSCRIPT)" && \
58 exit 1 || true ;\
59 [ -z $${oarch} ] && \
60 echo "Cannot read OUTPUT_ARCH from lds file $(LDSCRIPT)" && \
61 exit 1 || true ;\
62 \
63 cd $(dir ${DT_BIN}) && \
64 $(OBJCOPY) -I binary -O $${oformat} -B $${oarch} \
Masahiro Yamada9e414032014-02-04 17:24:24 +090065 $(notdir ${DT_BIN}) $(notdir $@)
Simon Glassbbb0b122011-10-15 05:48:21 +000066 rm $(DT_BIN)
67
Masahiro Yamadabcfe8fd2013-10-21 11:53:40 +090068obj-$(CONFIG_OF_EMBED) := dt.o
Simon Glassbbb0b122011-10-15 05:48:21 +000069
70binary: $(DT_BIN)